#include <stdio.h>
#include <iostream>
#include <pthread.h>

#include <fstream>
#include <sstream>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>

#include <stdlib.h>
#include <wiringPi.h>
#include<errno.h>		//Librerias para la comunicacion Serial 
#include<wiringSerial.h>	//Librerias para la comunicacion Serial
#include <string>
#include<wchar.h>

using namespace std;

#define Boton_Seleccion 0
#define Boton_Compara 3
#define Boton_Validar 2
//#define Boton_Adelante 3
//#define Boton_Atras 4

#define	ENCODER_A	4
#define	ENCODER_B	5

#define Ent_Braile_1 23
#define Ent_Braile_2 27
#define Ent_Braile_3 24
#define Ent_Braile_4 28
#define Ent_Braile_5 25
#define Ent_Braile_6 29


void ConfiguracionPerifericos(void);
void Rebote(void);
void MatarProcesos(void);
void EnviarSerial(void);
void* leerGPIO(void *n);
//------------------------------------------
//**********I MODOS***********
void* modoAyuda(void *n);
void* modoLecturaBraile(void *n);
void* modoEscrituraBraile(void *n);
void* Deletrear(void *n);
void* Deletrear_E(void *n);
void* EscribirPalabra(void *n);
//*********FIN I MODOS*********
//-------------------Variables del Programas-----------------------
int fd;		//Variable necesaria para la comunicacion serial.

bool AUX1=0,AUX2=0;

unsigned short int contador=0,cont_Lectura=0,cont_Escritura=0,cont_Palabra=0; 
unsigned short int apagar=0,i=0, Pala_pos_vector=0, borrar_texto=0;
//-------------------Alfabeto Braile Lectura-----------------------
bool Braile_A[6]={1,0,0,0,0,0}, Braile_E_A[6]={0,1,0,0,0,0};
bool Braile_B[6]={1,0,1,0,0,0}, Braile_E_B[6]={0,1,0,1,0,0};
bool Braile_C[6]={1,1,0,0,0,0}, Braile_E_C[6]={1,1,0,0,0,0};
bool Braile_D[6]={1,1,0,1,0,0}, Braile_E_D[6]={1,1,1,0,0,0};
bool Braile_E[6]={1,0,0,1,0,0}, Braile_E_E[6]={0,1,1,0,0,0}; 
bool Braile_F[6]={1,1,1,0,0,0}, Braile_E_F[6]={1,1,0,1,0,0};
bool Braile_G[6]={1,1,1,1,0,0}, Braile_E_G[6]={1,1,1,1,0,0};
bool Braile_H[6]={1,0,1,1,0,0}, Braile_E_H[6]={0,1,1,1,0,0};
bool Braile_I[6]={0,1,1,0,0,0}, Braile_E_I[6]={1,0,0,1,0,0};
bool Braile_J[6]={0,1,1,1,0,0}, Braile_E_J[6]={1,0,1,1,0,0};
bool Braile_K[6]={1,0,0,0,1,0}, Braile_E_K[6]={0,1,0,0,0,1};
bool Braile_L[6]={1,0,1,0,1,0}, Braile_E_L[6]={0,1,0,1,0,1};
bool Braile_M[6]={1,1,0,0,1,0}, Braile_E_M[6]={1,1,0,0,0,1};
bool Braile_N[6]={1,1,0,1,1,0}, Braile_E_N[6]={1,1,1,0,0,1};
bool Braile_ene[6]={1,1,1,1,0,1}, Braile_E_ene[6]={1,1,1,1,1,0};
bool Braile_O[6]={1,0,0,1,1,0}, Braile_E_O[6]={0,1,1,0,0,1};
bool Braile_P[6]={1,1,1,0,1,0}, Braile_E_P[6]={1,1,0,1,0,1};
bool Braile_Q[6]={1,1,1,1,1,0}, Braile_E_Q[6]={1,1,1,1,0,1};
bool Braile_R[6]={1,0,1,1,1,0}, Braile_E_R[6]={0,1,1,1,0,1};
bool Braile_S[6]={0,1,1,0,1,0}, Braile_E_S[6]={1,0,0,1,0,1};
bool Braile_T[6]={0,1,1,1,1,0}, Braile_E_T[6]={1,0,1,1,0,1}; 
bool Braile_U[6]={1,0,0,0,1,1}, Braile_E_U[6]={0,1,0,0,1,1};
bool Braile_V[6]={1,0,1,0,1,1}, Braile_E_V[6]={0,1,0,1,1,1};
bool Braile_W[6]={0,1,1,1,0,1}, Braile_E_W[6]={1,0,1,1,1,0};
bool Braile_X[6]={1,1,0,0,1,1}, Braile_E_X[6]={1,1,0,0,1,1};
bool Braile_Y[6]={1,1,0,1,1,1}, Braile_E_Y[6]={1,1,1,0,1,1}; 
bool Braile_Z[6]={1,0,0,1,1,1}, Braile_E_Z[6]={0,1,1,0,1,1};
//---------------------------------LETRAS CON TILDE---------------------------
bool Braile_A_tilde[6]={1,0,1,1,1,1}, Braile_E_A_tilde[6]={0,1,1,1,1,1};
bool Braile_E_tilde[6]={0,1,1,0,1,1}, Braile_E_E_tilde[6]={1,0,0,1,1,1};
bool Braile_I_tilde[6]={0,1,0,0,1,0}, Braile_E_I_tilde[6]={1,0,0,0,0,1};
bool Braile_O_tilde[6]={0,1,0,0,1,1}, Braile_E_O_tilde[6]={1,0,0,0,1,1};
bool Braile_U_tilde[6]={0,1,1,1,1,1}, Braile_E_U_tilde[6]={1,0,1,1,1,1};
//----------------------------------------------------------------------------------------
//---------------------------------SIGNOS DE PUNTUACION---------------------------
bool Braile_PUN[6]={0,0,0,0,1,0}, Braile_E_PUN[6]={0,0,0,0,0,1};
bool Braile_COMA[6]={0,0,1,0,0,0}, Braile_E_COMA[6]={0,0,0,1,0,0};//
bool Braile_PUNCOMA[6]={0,0,1,0,1,0}, Braile_E_PUNCOMA[6]={0,0,0,1,0,1};
bool Braile_DOSPUN[6]={0,0,1,1,0,0}, Braile_E_DOSPUN[6]={0,0,1,1,0,0};
bool Braile_PAREA[6]={1,0,1,0,0,1}, Braile_E_PAREA[6]={0,1,0,1,1,0};
bool Braile_PAREC[6]={0,1,0,1,1,0}, Braile_E_PAREC[6]={1,0,1,0,0,1};
bool Braile_PREG[6]={0,0,1,0,0,1}, Braile_E_PREG[6]={0,0,0,1,1,0};
bool Braile_ADMI[6]={0,0,1,1,1,0}, Braile_E_ADMI[6]={0,0,1,1,0,1};
bool Braile_MENOS[6]={0,0,0,0,1,1}, Braile_E_MENOS[6]={0,0,0,0,1,1};
bool Braile_MAS[6]={0,0,1,1,1,0}, Braile_E_MAS[6]={0,0,1,1,0,1};
bool Braile_IGUAL[6]={0,0,1,1,1,1}, Braile_E_IGUAL[6]={0,0,1,1,1,1};
//----------------------------------------------------------------------------------------
bool alma[6]={0,0,0,0,0,0};
bool comp[6]={0,0,0,0,0,0};
//++++++++++++++++++++++++++++++++++++++++++++++++
void ConfiguracionPerifericos(void){
	wiringPiSetup();
	cout<<"Hola"<<endl;
	pinMode(Boton_Seleccion, INPUT);
	pinMode(Boton_Compara, INPUT);
	pinMode(Boton_Validar, INPUT);
	pinMode(ENCODER_A, INPUT);//prueba
	pinMode(ENCODER_B, INPUT);//prueba
	pinMode(Ent_Braile_1, INPUT);
	pinMode(Ent_Braile_2, INPUT);
	pinMode(Ent_Braile_3, INPUT);
	pinMode(Ent_Braile_4, INPUT);
	pinMode(Ent_Braile_5, INPUT);
	pinMode(Ent_Braile_6, INPUT);
}
void Rebote(void){
	delay(15);
	while(digitalRead(Boton_Seleccion)==1){
		apagar=apagar+1;
		cout<<apagar<<endl;
		delay(10);
		}	
	while(/*digitalRead(Boton_Seleccion)==0 || */digitalRead(Boton_Compara)==0 || digitalRead(Boton_Validar)==0);// || digitalRead(Boton_Adelante)==1 || digitalRead(Boton_Atras)==1);
	delay(15);
}
void MatarProcesos(void){
	system("kill  $(pgrep festival) ");
	system("kill  $(pgrep aplay) ");
	system("kill  $(pgrep audsp) ");
	system("kill $(pgrep mpg123)");	
	system("clear");
}
void EnviarSerial(void){
	fd=serialOpen("/dev/ttyAMA0",9600);	
	wiringPiSetup();
	cout<<"Abriste el Puerto serial"<<endl;
	serialPutchar(fd,76);		//Escribes la letra L en el puerto serial, que es la orden para poder levantar la mano derecha.
	cout<<"Escribiste L en el Puerto serial"<<endl;
	delay(3);
	serialClose(fd);	
	cout<<"Cerraste el Puerto serial"<<endl;	
} 
//++++++++++++++++++++MODOS+++++++++++++++++++++
void* modoAyuda(void *n)
{	
	MatarProcesos();
	cout<<"Modo Ayuda"<<endl;
	system("sudo echo 'Modo Ayuda' | festival --tts");
	system("sudo less -f -r /home/pi/glove/Tutorial.txt | iconv -f utf-8 -t iso-8859-1 | festival --tts");	
}
void* modoLecturaBraile(void *n)
{	
	 MatarProcesos();
	 cout<<"Modo Lectura en Braile"<<endl;
	 system("sudo echo 'Modo Lectura en Braile' | festival --tts");
	 delay(100);
	 EnviarSerial();
	 for(i=0;i<=5;i++)
		alma[i]=Braile_A[i]; 
	 system("sudo echo 'Como se debe leer la letra A' | festival --tts");	
}
void* modoEscrituraBraile(void *n)
{	
	MatarProcesos();
	cout<<"Modo Escritura en Braile"<<endl;
	system("sudo echo 'Modo Escritura en Braile' | festival --tts");
	delay(100);
	EnviarSerial();
	for(i=0;i<=5;i++)
		alma[i]=Braile_E_A[i]; 
	 system("sudo echo 'Como se debe escribir la letra A' | festival --tts");
}
void* modoEscribirPalabras(void *n)
{	
	MatarProcesos();
	cout<<"Modo Escribir Palabras en Braile"<<endl;
	delay(100);
	system("sudo echo 'Modo Escribir Palabras en Braile' | festival --tts");	
}
//------------------------------------------------------------------------------------------------------
//++++++++++++++++++++++++++PROCESO DE DELETREO PARA MODO LECTURA++++++++++++++++++++++++++++
void* Deletrear(void *n)
{	
	 EnviarSerial();
	switch(cont_Lectura)
	{	
		case 0://Como se debe leer la Letra A
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_A[i]; system("sudo echo 'Como se debe leer la letra A' | festival --tts");
		break;
		case 1://Como se debe leer la Letra B
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_B[i]; system("sudo echo 'Como se debe leer la letra B' | festival --tts"); 
		break;
		case 2://Como se debe leer la Letra C
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_C[i]; system("sudo echo 'Como se debe leer la letra C' | festival --tts");
		break;
		case 3://Como se debe leer la Letra D
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_D[i]; system("sudo echo 'Como se debe leer la letra D' | festival --tts");
		break;
		case 4://Como se debe leer la Letra E
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E[i]; system("sudo echo 'Como se debe leer la letra E' | festival --tts");
		break;
		case 5://Como se debe leer la Letra F
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_F[i]; system("sudo echo 'Como se debe leer la letra F' | festival --tts");
		break;
		case 6://Como se debe leer la Letra G
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_G[i]; system("sudo echo 'Como se debe leer la letra G' | festival --tts");
		break;
		case 7://Como se debe leer la Letra H
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_H[i]; system("sudo echo 'Como se debe leer la letra H' | festival --tts");
		break;
		case 8://Como se debe leer la Letra I
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_I[i]; system("sudo echo 'Como se debe leer la letra I' | festival --tts");
		break;
		case 9://Como se debe leer la Letra J
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_J[i]; system("sudo echo 'Como se debe leer la letra J' | festival --tts");
		break;
		case 10://Como se debe leer la Letra K
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_K[i]; system("sudo echo 'Como se debe leer la letra K' | festival --tts");
		break;
		case 11://Como se debe leer la Letra L
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_L[i]; system("sudo echo 'Como se debe leer la letra L' | festival --tts");
		break;
		case 12://Como se debe leer la Letra M
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_M[i]; system("sudo echo 'Como se debe leer la letra M' | festival --tts");
		break;
		case 13://Como se debe leer la Letra N
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_N[i]; system("sudo echo 'Como se debe leer la letra N' | festival --tts");
		break;
		case 14://Como se debe leer la Letra Ñ
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_ene[i]; system("sudo -r -f echo 'Como se debe leer la letra eñe' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 15://Como se debe leer la Letra O
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_O[i]; system("sudo echo 'Como se debe leer la letra O' | festival --tts");
		break;
		case 16://Como se debe leer la Letra P
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_P[i]; system("sudo echo 'Como se debe leer la letra P' | festival --tts");
		break;
		case 17://Como se debe leer la Letra Q
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_Q[i]; system("sudo echo 'Como se debe leer la letra Q' | festival --tts");
		break;
		case 18://Como se debe leer la Letra R
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_R[i]; system("sudo echo 'Como se debe leer la letra R' | festival --tts");
		break;
		case 19://Como se debe leer la Letra S
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_S[i]; system("sudo echo 'Como se debe leer la letra S' | festival --tts");
		break;
		case 20://Como se debe leer la Letra T
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_T[i]; system("sudo echo 'Como se debe leer la letra T' | festival --tts");
		break;
		case 21://Como se debe leer la Letra U
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_U[i]; system("sudo echo 'Como se debe leer la letra U' | festival --tts");
		break;
		case 22://Como se debe leer la Letra V
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_V[i]; system("sudo -r -f echo 'Como se debe leer la letra ve pequeña' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 23://Como se debe leer la Letra W
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_W[i]; system("sudo echo 'Como se debe leer la letra deble u' | festival --tts");
		break;
		case 24://Como se debe leer la Letra X
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_X[i]; system("sudo echo 'Como se debe leer la letra X' | festival --tts");
		break;
		case 25://Como se debe leer la Letra Y
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_Y[i]; system("sudo echo 'Como se debe leer la letra Y griega' | festival --tts");
		break;
		case 26://Como se debe leer la Letra Z
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_Z[i]; system("sudo echo 'Como se debe leer la letra Z' | festival --tts");
		break;
		//---------------------------------------------------------------LETRAS CON TILDE----------------------------------------------------------------
		case 27://Como se debe leer la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_A_tilde[i]; system("sudo echo 'Como se debe leer la letra A con tilde' | festival --tts");
		break;
		case 28://Como se debe leer la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_tilde[i]; system("sudo echo 'Como se debe leer la letra E con tilde' | festival --tts");
		break;
		case 29://Como se debe leer la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_I_tilde[i]; system("sudo echo 'Como se debe leer la letra I con tilde' | festival --tts");
		break;
		case 30://Como se debe leer la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_O_tilde[i]; system("sudo echo 'Como se debe leer la letra O con tilde' | festival --tts");
		break;
		case 31://Como se debe leer la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_U_tilde[i]; system("sudo echo 'Como se debe leer la letra U con tilde' | festival --tts");
		break;
		//------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------SIGNOS DE PUNTUACION--------------------------------------------------------------
		case 32://Como se debe leer el punto
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_PUN[i]; system("sudo echo 'Como se debe leer el punto' | festival --tts");
		break;
		case 33://Como se debe leer la coma
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_COMA[i]; system("sudo echo 'Como se debe leer la coma' | festival --tts");
		break;
		case 34://Como se debe leer el punto y coma
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_PUNCOMA[i]; system("sudo echo 'Como se debe leer el punto y coma' | festival --tts");
		break;
		case 35://Como se debe leer los dos puntos
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_DOSPUN[i]; system("sudo echo 'Como se debe leer los dos puntos' | festival --tts");
		break;
		case 36://Como se debe leer el abrir parentesis
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_PAREA[i]; system("sudo echo 'Como se debe leer el abrir parentesis' | festival --tts");
		break;
		case 37://Como se debe leer el cerrar parentesis
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_PAREC[i]; system("sudo echo 'Como se debe leer el cerrar parentesis' | festival --tts");
		break;
		case 38://Como se debe leer el signo de pregunta
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_PREG[i]; system("sudo echo 'Como se debe leer el signo de pregunta' | festival --tts");
		break;
		case 39://Como se debe leer el signo de admiración
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_ADMI[i]; system("sudo -r -f echo 'Como se debe leer el signo de admiración' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 40://Como se debe leer el signo menos
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_MENOS[i]; system("sudo -r -f echo 'Como se debe leer el signo de menos' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 41://Como se debe leer el signo más
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_MAS[i]; system("sudo -r -f echo 'Como se debe leer el signo más' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 42://Como se debe leer el signo igual
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_IGUAL[i]; system("sudo -r -f echo 'Como se debe leer el signo igual' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		//------------------------------------------------------------------------------------------------------------------------------------------------------------
	default:		
		break;
	}
}		
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++PROCESO DE DELETREO PARA MODO ESCRITURA++++++++++++++++++++++++++
void* Deletrear_E(void *n)
{	
	EnviarSerial();
	switch(cont_Lectura)
	{	
		case 0://Como se debe escribir la Letra A
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_A[i]; system("sudo echo 'Como se debe escribir la letra A' | festival --tts");
		break;
		case 1://Como se debe escribir la Letra B
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_B[i]; system("sudo echo 'Como se debe escribir la letra B' | festival --tts");
		break;
		case 2://Como se debe escribir la Letra C
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_C[i]; system("sudo echo 'Como se debe escribir la letra C' | festival --tts");
		break;
		case 3://Como se debe escribir la Letra D
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_D[i]; system("sudo echo 'Como se debe escribir la letra D' | festival --tts");
		break;
		case 4://Como se debe escribir la Letra E
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_E[i]; system("sudo echo 'Como se debe escribir la letra E' | festival --tts");
		break;
		case 5://Como se debe escribir la Letra F
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_F[i]; system("sudo echo 'Como se debe escribir la letra F' | festival --tts");
		break;
		case 6://Como se debe escribir la Letra G
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_G[i]; system("sudo echo 'Como se debe escribir la letra G' | festival --tts");
		break;
		case 7://Como se debe escribir la Letra H
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_H[i]; system("sudo echo 'Como se debe escribir la letra H' | festival --tts");
		break;
		case 8://Como se debe escribir la Letra I
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_I[i]; system("sudo echo 'Como se debe escribir la letra I' | festival --tts");
		break;
		case 9://Como se debe escribir la Letra J
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_J[i]; system("sudo echo 'Como se debe escribir la letra J' | festival --tts");
		break;
		case 10://Como se debe escribir la Letra K
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_K[i]; system("sudo echo 'Como se debe escribir la letra K' | festival --tts");
		break;
		case 11://Como se debe escribir la Letra L
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_L[i]; system("sudo echo 'Como se debe escribir la letra L' | festival --tts");
		break;
		case 12://Como se debe escribir la Letra M
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_M[i]; system("sudo echo 'Como se debe escribir la letra M' | festival --tts");
		break;
		case 13://Como se debe escribir la Letra N
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_N[i]; system("sudo echo 'Como se debe escribir la letra N' | festival --tts");
		break;
		case 14://Como se debe escribir la Letra Ñ
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_ene[i]; system("sudo -r -f echo 'Como se debe escribir la letra eñe' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 15://Como se debe escribir la Letra O
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_O[i]; system("sudo echo 'Como se debe escribir la letra O' | festival --tts");
		break;
		case 16://Como se debe escribir la Letra P
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_P[i]; system("sudo echo 'Como se debe escribir la letra P' | festival --tts");
		break;
		case 17://Como se debe escribir la Letra Q
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_Q[i]; system("sudo echo 'Como se debe escribir la letra Q' | festival --tts");
		break;
		case 18://Como se debe escribir la Letra R
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_R[i]; system("sudo echo 'Como se debe escribir la letra R' | festival --tts");
		break;
		case 19://Como se debe escribir la Letra S
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_S[i]; system("sudo echo 'Como se debe escribir la letra S' | festival --tts");
		break;
		case 20://Como se debe escribir la Letra T
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_T[i]; system("sudo echo 'Como se debe escribir la letra T' | festival --tts");
		break;
		case 21://Como se debe escribir la Letra U
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_U[i]; system("sudo echo 'Como se debe escribir la letra U' | festival --tts");
		break;
		case 22://Como se debe escribir la Letra V
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_V[i]; system("sudo -r -f echo 'Como se debe escribir la letra ve pequeña' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 23://Como se debe escribir la Letra W
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_W[i]; system("sudo echo 'Como se debe escribir la letra doble u' | festival --tts");
		break;
		case 24://Como se debe escribir la Letra X
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_X[i]; system("sudo echo 'Como se debe escribir la letra X' | festival --tts");
		break;
		case 25://Como se debe escribir la Letra Y
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_Y[i]; system("sudo echo 'Como se debe escribir la letra Y griega' | festival --tts");
		break;
		case 26://Como se debe escribir la Letra Z
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_Z[i]; system("sudo echo 'Como se debe escribir la letra Z' | festival --tts");
		break;
		//---------------------------------------------------------------LETRAS CON TILDE----------------------------------------------------------------
		case 27://Como se debe escribir la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_A_tilde[i]; system("sudo echo 'Como se debe escribir la letra A con tilde' | festival --tts");
		break;
		case 28://Como se debe escribir la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_E_tilde[i]; system("sudo echo 'Como se debe escribir la letra E con tilde' | festival --tts");
		break;
		case 29://Como se debe escribir la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_I_tilde[i]; system("sudo echo 'Como se debe escribir la letra I con tilde' | festival --tts");
		break;
		case 30://Como se debe escribir la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_O_tilde[i]; system("sudo echo 'Como se debe escribir la letra O con tilde' | festival --tts");
		break;
		case 31://Como se debe escribir la A tildada
			for(i=0;i<=5;i++)
			 	alma[i]=Braile_E_U_tilde[i]; system("sudo echo 'Como se debe escribir la letra U con tilde' | festival --tts");
		break;
		//------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------SIGNOS DE PUNTUACION--------------------------------------------------------------
		case 32://Como se debe escribir el punto
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_PUN[i]; system("sudo echo 'Como se debe escribir el punto' | festival --tts");
		break;
		case 33://Como se debe escribir la coma
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_COMA[i]; system("sudo echo 'Como se debe escribir la coma' | festival --tts");
		break;
		case 34://Como se debe escribir el punto y coma
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_PUNCOMA[i]; system("sudo echo 'Como se debe escribir el punto y coma' | festival --tts");
		break;
		case 35://Como se debe escribir los dos puntos
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_DOSPUN[i]; system("sudo echo 'Como se debe escribir los dos puntos' | festival --tts");
		break;
		case 36://Como se debe escribir el abrir parentesis
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_PAREA[i]; system("sudo echo 'Como se debe escribir el abrir parentesis' | festival --tts");
		break;
		case 37://Como se debe escribir el cerrar parentesis
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_PAREC[i]; system("sudo echo 'Como se debe escribir el cerrar parentesis' | festival --tts");
		break;
		case 38://Como se debe escribir el signo de pregunta
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_PREG[i]; system("sudo echo 'Como se debe escribir el signo de pregunta' | festival --tts");
		break;
		case 39://Como se debe escribir el signo de admiración
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_ADMI[i]; system("sudo -r -f echo 'Como se debe escribir el signo de admiración' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 40://Como se debe escribir el signo menos
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_MENOS[i]; system("sudo -r -f echo 'Como se debe escribir el signo de menos' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 41://Como se debe escribir el signo más
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_MAS[i]; system("sudo -r -f echo 'Como se debe escribir el signo más' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		case 42://Como se debe escribir el signo igual
			for(i=0;i<=5;i++)
			 	alma[i]= Braile_E_IGUAL[i]; system("sudo -r -f echo 'Como se debe escribir el signo igual' | iconv -f utf-8 -t iso-8859-1 |festival --tts");
		break;
		//------------------------------------------------------------------------------------------------------------------------------------------------------------
	default:		
		break;
	}
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++PROCESO DE DELETREO PARA MODO ESCRITURA++++++++++++++++++++++++++
void* EscribirPalabra(void *n){
	if(comp[0]==0 && comp[1]==0 && comp[2]==0 && comp[3]==0 && comp[4]==0 && comp[5]==0){
		system("echo -n ' ' >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste espacio"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Espacio' | festival --tts");}
	if(comp[0]==Braile_E_A[0] && comp[1]==Braile_E_A[1] && comp[2]==Braile_E_A[2] && comp[3]==Braile_E_A[3] && comp[4]==Braile_E_A[4] && comp[5]==Braile_E_A[5]){
		system("echo -n A >> /home/pi/glove/Palabra_Braile_2.txt "); cout<<"escribiste A"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste A' | festival --tts");}
	if(comp[0]==Braile_E_B[0] && comp[1]==Braile_E_B[1] && comp[2]==Braile_E_B[2] && comp[3]==Braile_E_B[3] && comp[4]==Braile_E_B[4] && comp[5]==Braile_E_B[5]){
		system("echo -n B >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste B"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste B' | festival --tts");}
	if(comp[0]==Braile_E_C[0] && comp[1]==Braile_E_C[1] && comp[2]==Braile_E_C[2] && comp[3]==Braile_E_C[3] && comp[4]==Braile_E_C[4] && comp[5]==Braile_E_C[5]){
		system("echo -n C >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste C"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste C' | festival --tts");}
	if(comp[0]==Braile_E_D[0] && comp[1]==Braile_E_D[1] && comp[2]==Braile_E_D[2] && comp[3]==Braile_E_D[3] && comp[4]==Braile_E_D[4] && comp[5]==Braile_E_D[5]){
		system("echo -n D >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste D"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste D' | festival --tts");}
	if(comp[0]==Braile_E_E[0] && comp[1]==Braile_E_E[1] && comp[2]==Braile_E_E[2] && comp[3]==Braile_E_E[3] && comp[4]==Braile_E_E[4] && comp[5]==Braile_E_E[5]){
		system("echo -n E >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste E"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste E' | festival --tts");}
	if(comp[0]==Braile_E_F[0] && comp[1]==Braile_E_F[1] && comp[2]==Braile_E_F[2] && comp[3]==Braile_E_F[3] && comp[4]==Braile_E_F[4] && comp[5]==Braile_E_F[5]){
		system("echo -n F >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste F"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste F' | festival --tts");}
	if(comp[0]==Braile_E_G[0] && comp[1]==Braile_E_G[1] && comp[2]==Braile_E_G[2] && comp[3]==Braile_E_G[3] && comp[4]==Braile_E_G[4] && comp[5]==Braile_E_G[5]){
		system("echo -n G >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste G"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste G' | festival --tts");}
	if(comp[0]==Braile_E_H[0] && comp[1]==Braile_E_H[1] && comp[2]==Braile_E_H[2] && comp[3]==Braile_E_H[3] && comp[4]==Braile_E_H[4] && comp[5]==Braile_E_H[5]){
		system("echo -n H >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste H"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste H' | festival --tts");}
	if(comp[0]==Braile_E_I[0] && comp[1]==Braile_E_I[1] && comp[2]==Braile_E_I[2] && comp[3]==Braile_E_I[3] && comp[4]==Braile_E_I[4] && comp[5]==Braile_E_I[5]){
		system("echo -n I >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste I"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste I' | festival --tts");}
	if(comp[0]==Braile_E_J[0] && comp[1]==Braile_E_J[1] && comp[2]==Braile_E_J[2] && comp[3]==Braile_E_J[3] && comp[4]==Braile_E_J[4] && comp[5]==Braile_E_J[5]){
		system("echo -n J >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste J"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste J' | festival --tts");}
	if(comp[0]==Braile_E_K[0] && comp[1]==Braile_E_K[1] && comp[2]==Braile_E_K[2] && comp[3]==Braile_E_K[3] && comp[4]==Braile_E_K[4] && comp[5]==Braile_E_K[5]){
		system("echo -n K >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste K"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste K' | festival --tts");}
	if(comp[0]==Braile_E_L[0] && comp[1]==Braile_E_L[1] && comp[2]==Braile_E_L[2] && comp[3]==Braile_E_L[3] && comp[4]==Braile_E_L[4] && comp[5]==Braile_E_L[5]){
		system("echo -n L >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste L"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste L' | festival --tts");}
	if(comp[0]==Braile_E_M[0] && comp[1]==Braile_E_M[1] && comp[2]==Braile_E_M[2] && comp[3]==Braile_E_M[3] && comp[4]==Braile_E_M[4] && comp[5]==Braile_E_M[5]){
		system("echo -n M >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste M"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste M' | festival --tts");}
	if(comp[0]==Braile_E_N[0] && comp[1]==Braile_E_N[1] && comp[2]==Braile_E_N[2] && comp[3]==Braile_E_N[3] && comp[4]==Braile_E_N[4] && comp[5]==Braile_E_N[5]){
		system("echo -n N >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste N"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste N' | festival --tts");}
	if(comp[0]==Braile_E_ene[0] && comp[1]==Braile_E_ene[1] && comp[2]==Braile_E_ene[2] && comp[3]==Braile_E_ene[3] && comp[4]==Braile_E_ene[4] && comp[5]==Braile_E_ene[5]){
		system("echo -n Ñ >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste Ñ"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo -r -f echo 'escribiste eñe' | iconv -f utf-8 -t iso-8859-1 |festival --tts");}
	if(comp[0]==Braile_E_O[0] && comp[1]==Braile_E_O[1] && comp[2]==Braile_E_O[2] && comp[3]==Braile_E_O[3] && comp[4]==Braile_E_O[4] && comp[5]==Braile_E_O[5]){
		system("echo -n O >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste O"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste O' | festival --tts");}
	if(comp[0]==Braile_E_P[0] && comp[1]==Braile_E_P[1] && comp[2]==Braile_E_P[2] && comp[3]==Braile_E_P[3] && comp[4]==Braile_E_P[4] && comp[5]==Braile_E_P[5]){
		system("echo -n P >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste P"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste P' | festival --tts");}
	if(comp[0]==Braile_E_Q[0] && comp[1]==Braile_E_Q[1] && comp[2]==Braile_E_Q[2] && comp[3]==Braile_E_Q[3] && comp[4]==Braile_E_Q[4] && comp[5]==Braile_E_Q[5]){
		system("echo -n Q >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste Q"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste Q' | festival --tts");}
	if(comp[0]==Braile_E_R[0] && comp[1]==Braile_E_R[1] && comp[2]==Braile_E_R[2] && comp[3]==Braile_E_R[3] && comp[4]==Braile_E_R[4] && comp[5]==Braile_E_R[5]){
		system("echo -n R >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste R"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste R' | festival --tts");}
	if(comp[0]==Braile_E_S[0] && comp[1]==Braile_E_S[1] && comp[2]==Braile_E_S[2] && comp[3]==Braile_E_S[3] && comp[4]==Braile_E_S[4] && comp[5]==Braile_E_S[5]){
		system("echo -n S >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste S"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste S' | festival --tts");}
	if(comp[0]==Braile_E_T[0] && comp[1]==Braile_E_T[1] && comp[2]==Braile_E_T[2] && comp[3]==Braile_E_T[3] && comp[4]==Braile_E_T[4] && comp[5]==Braile_E_T[5]){
		system("echo -n T >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste T"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste T' | festival --tts");}
	if(comp[0]==Braile_E_U[0] && comp[1]==Braile_E_U[1] && comp[2]==Braile_E_U[2] && comp[3]==Braile_E_U[3] && comp[4]==Braile_E_U[4] && comp[5]==Braile_E_U[5]){
		system("echo -n U >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste U"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste U' | festival --tts");}
	if(comp[0]==Braile_E_V[0] && comp[1]==Braile_E_V[1] && comp[2]==Braile_E_V[2] && comp[3]==Braile_E_V[3] && comp[4]==Braile_E_V[4] && comp[5]==Braile_E_V[5]){
		system("echo -n V >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste V"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo -r -f echo 'escribiste ve pequeña' | iconv -f utf-8 -t iso-8859-1 |festival --tts");}
	if(comp[0]==Braile_E_W[0] && comp[1]==Braile_E_W[1] && comp[2]==Braile_E_W[2] && comp[3]==Braile_E_W[3] && comp[4]==Braile_E_W[4] && comp[5]==Braile_E_W[5]){
		system("echo -n W >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste W"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste doble u' | festival --tts");}
	if(comp[0]==Braile_E_X[0] && comp[1]==Braile_E_X[1] && comp[2]==Braile_E_X[2] && comp[3]==Braile_E_X[3] && comp[4]==Braile_E_X[4] && comp[5]==Braile_E_X[5]){
		system("echo -n X >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste X"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste X' | festival --tts");}
	if(comp[0]==Braile_E_Y[0] && comp[1]==Braile_E_Y[1] && comp[2]==Braile_E_Y[2] && comp[3]==Braile_E_Y[3] && comp[4]==Braile_E_Y[4] && comp[5]==Braile_E_Y[5]){
		system("echo -n Y >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste Y"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Como se debe escribir la letra Y griega' | festival --tts");}
	if(comp[0]==Braile_E_Z[0] && comp[1]==Braile_E_Z[1] && comp[2]==Braile_E_Z[2] && comp[3]==Braile_E_Z[3] && comp[4]==Braile_E_Z[4] && comp[5]==Braile_E_Z[5]){
		system("echo -n Z >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste Z"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste Z' | festival --tts");}
	//---------------------------------------------------------------LETRAS CON TILDE----------------------------------------------------------------
	if(comp[0]==Braile_E_A_tilde[0] && comp[1]==Braile_E_A_tilde[1] && comp[2]==Braile_E_A_tilde[2] && comp[3]==Braile_E_A_tilde[3] && comp[4]==Braile_E_A_tilde[4] && comp[5]==Braile_E_A_tilde[5]){
		system("echo -n Á >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste A con tilde"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste A CON TILDE' | festival --tts");}
	if(comp[0]==Braile_E_E_tilde[0] && comp[1]==Braile_E_E_tilde[1] && comp[2]==Braile_E_E_tilde[2] && comp[3]==Braile_E_E_tilde[3] && comp[4]==Braile_E_E_tilde[4] && comp[5]==Braile_E_E_tilde[5]){
		system("echo -n É >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste E con tilde"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste E CON TILDE' | festival --tts");}
	if(comp[0]==Braile_E_I_tilde[0] && comp[1]==Braile_E_I_tilde[1] && comp[2]==Braile_E_I_tilde[2] && comp[3]==Braile_E_I_tilde[3] && comp[4]==Braile_E_I_tilde[4] && comp[5]==Braile_E_I_tilde[5]){
		system("echo -n Í >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste I con tilde"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste I CON TILDE' | festival --tts");}
	if(comp[0]==Braile_E_O_tilde[0] && comp[1]==Braile_E_O_tilde[1] && comp[2]==Braile_E_O_tilde[2] && comp[3]==Braile_E_O_tilde[3] && comp[4]==Braile_E_O_tilde[4] && comp[5]==Braile_E_O_tilde[5]){
		system("echo -n Ó >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste O con tilde"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste O CON TILDE' | festival --tts");}
	if(comp[0]==Braile_E_U_tilde[0] && comp[1]==Braile_E_U_tilde[1] && comp[2]==Braile_E_U_tilde[2] && comp[3]==Braile_E_U_tilde[3] && comp[4]==Braile_E_U_tilde[4] && comp[5]==Braile_E_U_tilde[5]){
		system("echo -n Ú >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste U con tilde"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste U CON TILDE' | festival --tts");}
	//------------------------------------------------------------------------------------------------------------------------------------------------------------
	//---------------------------------------------------------SIGNOS DE PUNTUACION--------------------------------------------------------------
	if(comp[0]==Braile_E_PUN[0] && comp[1]==Braile_E_PUN[1] && comp[2]==Braile_E_PUN[2] && comp[3]==Braile_E_PUN[3] && comp[4]==Braile_E_PUN[4] && comp[5]==Braile_E_PUN[5]){
		system("echo -n . >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste punto"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Escribiste el punto' | festival --tts");}
	if(comp[0]==Braile_E_COMA[0] && comp[1]==Braile_E_COMA[1] && comp[2]==Braile_E_COMA[2] && comp[3]==Braile_E_COMA[3] && comp[4]==Braile_E_COMA[4] && comp[5]==Braile_E_COMA[5]){
		system("echo -n , >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste coma"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Escribiste la coma' | festival --tts");}
	if(comp[0]==Braile_E_PUNCOMA[0] && comp[1]==Braile_E_PUNCOMA[1] && comp[2]==Braile_E_PUNCOMA[2] && comp[3]==Braile_E_PUNCOMA[3] && comp[4]==Braile_E_PUNCOMA[4] && comp[5]==Braile_E_PUNCOMA[5]){
		system("echo -n ; >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste punto y coma"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Escribiste el punto y coma' | festival --tts");}
	if(comp[0]==Braile_E_DOSPUN[0] && comp[1]==Braile_E_DOSPUN[1] && comp[2]==Braile_E_DOSPUN[2] && comp[3]==Braile_E_DOSPUN[3] && comp[4]==Braile_E_DOSPUN[4] && comp[5]==Braile_E_DOSPUN[5]){
		system("echo -n : >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste dos puntos"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'Escribiste los dos puntos' | festival --tts");}
	if(comp[0]==Braile_E_PAREA[0] && comp[1]==Braile_E_PAREA[1] && comp[2]==Braile_E_PAREA[2] && comp[3]==Braile_E_PAREA[3] && comp[4]==Braile_E_PAREA[4] && comp[5]==Braile_E_PAREA[5]){
		system("echo -n '(' >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste PARENTESIS A"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo -r -f echo 'Abriste el signo de paréntesis' | iconv -f utf-8 -t iso-8859-1 |festival --tts");}
	if(comp[0]==Braile_E_PAREC[0] && comp[1]==Braile_E_PAREC[1] && comp[2]==Braile_E_PAREC[2] && comp[3]==Braile_E_PAREC[3] && comp[4]==Braile_E_PAREC[4] && comp[5]==Braile_E_PAREC[5]){
		system("echo -n ')' >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste PARENTESIS C"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo -r -f echo 'Cerraste el signo de paréntesis' | iconv -f utf-8 -t iso-8859-1 |festival --tts");}
	if(comp[0]==Braile_E_PREG[0] && comp[1]==Braile_E_PREG[1] && comp[2]==Braile_E_PREG[2] && comp[3]==Braile_E_PREG[3] && comp[4]==Braile_E_PREG[4] && comp[5]==Braile_E_PREG[5]){
		system("echo -n ¿ >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste PREGUNTA"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo echo 'escribiste el signo de pregunta' | festival --tts");}
	if(comp[0]==Braile_E_ADMI[0] && comp[1]==Braile_E_ADMI[1] && comp[2]==Braile_E_ADMI[2] && comp[3]==Braile_E_ADMI[3] && comp[4]==Braile_E_ADMI[4] && comp[5]==Braile_E_ADMI[5]){
		system("echo -n ¡ >> /home/pi/glove/Palabra_Braile_2.txt"); cout<<"escribiste Admiracion"<<endl; Pala_pos_vector=Pala_pos_vector+1; cout<<Pala_pos_vector<<endl;
		system("sudo -r -f echo 'escribiste el signo de admiración' | iconv -f utf-8 -t iso-8859-1 |festival --tts");}
	//------------------------------------------------------------------------------------------------------------------------------------------------------------
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++FIN MODOS+++++++++++++++++++++++++++++++++++++++++++
void* leerGPIO(void *n)
{
	ConfiguracionPerifericos();	
	pthread_t t1,t2;
	system("sudo less -f -r /home/pi/glove/Bienvenida.txt | iconv -f utf-8 -t iso-8859-1 | festival --tts");
	sleep(0.5);
	while(true)
	{
//------------------------------------CONDICION LECTURA EN BRAILE---------------------------------
		if(digitalRead(Boton_Compara)==0 && contador==1){
			Rebote();
			MatarProcesos();
			comp[0]=digitalRead(Ent_Braile_1);
			comp[1]=digitalRead(Ent_Braile_2);
			comp[2]=digitalRead(Ent_Braile_3);
			comp[3]=digitalRead(Ent_Braile_4);
			comp[4]=digitalRead(Ent_Braile_5);
			comp[5]=digitalRead(Ent_Braile_6);
			if(comp[0]==alma[0] && comp[1]==alma[1] && comp[2]==alma[2] && comp[3]==alma[3] && comp[4]==alma[4] && comp[5]==alma[5]){
				pthread_cancel(t1);
				//-------------------------ENVIO DE ESTIMULO CORRECTO DEL ROBOT POR EL PUERTO SERIAL
				fd=serialOpen("/dev/ttyAMA0",9600);	
				wiringPiSetup();
				cout<<"Abriste el Puerto serial"<<endl;
				serialPutchar(fd,67);
				cout<<"Escribiste C en el Puerto serial"<<endl; //ENVIO DE LA LETRA C POR EL PUERTO SERIAL
				delay(3);
				serialClose(fd);	
				cout<<"Cerraste el Puerto serial"<<endl;
				//----------------------------------------------------------------------------------------------------------------------------
				cout<<"correcto"<<endl;
				system("sudo echo 'Correcto' | festival --tts");
				cont_Lectura=cont_Lectura+1;
				pthread_create(&t1, NULL, &Deletrear, (void*)1); 
			}
			else{
				pthread_cancel(t1);
				//-----------------------ENVIO DE ESTIMULO INCORRECTO DEL ROBOT POR EL PUERTO SERIAL
				fd=serialOpen("/dev/ttyAMA0",9600);	
				wiringPiSetup();
				cout<<"Abriste el Puerto serial"<<endl;
				serialPutchar(fd,73);
				cout<<"Escribiste I en el Puerto serial"<<endl; //ENVIO DE LA LETRA I POR EL PUERTO SERIAL
				delay(3);
				serialClose(fd);	
				cout<<"Cerraste el Puerto serial"<<endl;
				//----------------------------------------------------------------------------------------------------------------------------
				cout<<"incorrecto"<<endl;
				system("sudo -r -f echo 'Incorrecto, Inténtalo de nuevo' | iconv -f utf-8 -t iso-8859-1 | festival --tts");
				pthread_create(&t1, NULL, &Deletrear, (void*)1);
			}
			if(cont_Lectura==43)
				cont_Lectura=0;
		}
//------------------------------------------CONDICION ESCRITURA EN BRAILE-----------------------------------------------
		if(digitalRead(Boton_Compara)==0 && contador==2){
			Rebote();
			MatarProcesos();
			comp[0]=digitalRead(Ent_Braile_1);
			comp[1]=digitalRead(Ent_Braile_2);
			comp[2]=digitalRead(Ent_Braile_3);
			comp[3]=digitalRead(Ent_Braile_4);
			comp[4]=digitalRead(Ent_Braile_5);
			comp[5]=digitalRead(Ent_Braile_6);
			if(comp[0]==alma[0] && comp[1]==alma[1] && comp[2]==alma[2] && comp[3]==alma[3] && comp[4]==alma[4] && comp[5]==alma[5]){
				pthread_cancel(t1);
				//-------------------------ENVIO DE ESTIMULO CORRECTO DEL ROBOT POR EL PUERTO SERIAL
				fd=serialOpen("/dev/ttyAMA0",9600);	
				wiringPiSetup();
				cout<<"Abriste el Puerto serial"<<endl;
				serialPutchar(fd,67);
				cout<<"Escribiste C en el Puerto serial"<<endl; //ENVIO DE LA LETRA C POR EL PUERTO SERIAL
				delay(3);
				serialClose(fd);	
				cout<<"Cerraste el Puerto serial"<<endl;
				//----------------------------------------------------------------------------------------------------------------------------
				cout<<"correcto"<<endl;
				system("sudo echo 'Correcto' | festival --tts");
				cont_Lectura=cont_Lectura+1;
				pthread_create(&t1, NULL, &Deletrear_E, (void*)1); 	
			}
			else{
				pthread_cancel(t1);
				//-----------------------ENVIO DE ESTIMULO INCORRECTO DEL ROBOT POR EL PUERTO SERIAL
				fd=serialOpen("/dev/ttyAMA0",9600);	
				wiringPiSetup();
				cout<<"Abriste el Puerto serial"<<endl;
				serialPutchar(fd,73);
				cout<<"Escribiste I en el Puerto serial"<<endl; //ENVIO DE LA LETRA I POR EL PUERTO SERIAL
				delay(3);
				serialClose(fd);	
				cout<<"Cerraste el Puerto serial"<<endl;
				//----------------------------------------------------------------------------------------------------------------------------
				cout<<"incorrecto"<<endl;
				system("sudo -r -f echo 'Incorrecto, Inténtalo de nuevo' | iconv -f utf-8 -t iso-8859-1 | festival --tts");
				pthread_create(&t1, NULL, &Deletrear_E, (void*)1);
			}
			if(cont_Lectura==43)
				cont_Lectura=0;
		}
//----------------------------------CONDICION ESCRIBIR PALABRAS EN BRAILE----------------------------------------
		if(digitalRead(Boton_Validar)==0 && contador==3){
			Rebote();
			MatarProcesos();
			if(borrar_texto==1){
				system("echo -n ' ' > /home/pi/glove/Palabra_Braile_2.txt");
				delay(500);
				borrar_texto=0;
			}	
			comp[0]=digitalRead(Ent_Braile_1);
			comp[1]=digitalRead(Ent_Braile_2);
			comp[2]=digitalRead(Ent_Braile_3);
			comp[3]=digitalRead(Ent_Braile_4);
			comp[4]=digitalRead(Ent_Braile_5);
			comp[5]=digitalRead(Ent_Braile_6);
			pthread_cancel(t1);
			pthread_create(&t1, NULL, &EscribirPalabra, (void*)1);
		}
		if(digitalRead(Boton_Compara)==0 && contador==3){
			Rebote();
			MatarProcesos();
			Pala_pos_vector=0;
			borrar_texto=1;
			delay(500);
			system("sudo less -f -r /home/pi/glove/Palabra_Braile_2.txt | iconv -f utf-8 -t iso-8859-1 | festival --tts");
		}
		
//*************************************************************************************************
		if(digitalRead(ENCODER_A) && !digitalRead(ENCODER_B)){
			AUX1=1;
			AUX2=0;
		}
		if(!digitalRead(ENCODER_A) && !digitalRead(ENCODER_B) && AUX1==1)
		{
			AUX1=0;
			delay(1);
			cont_Lectura=cont_Lectura+1;
			MatarProcesos();
			pthread_cancel(t1);
			cout<<cont_Lectura<<endl; 
			if(contador==1)
				pthread_create(&t1, NULL, &Deletrear, (void*)1);
			if(contador==2)
				pthread_create(&t1, NULL, &Deletrear_E, (void*)1);
		}
		if(!digitalRead(ENCODER_A) && digitalRead(ENCODER_B)){
			AUX1=0;
			AUX2=1;
		}
		if(!digitalRead(ENCODER_A) && !digitalRead(ENCODER_B) && AUX2==1)
		{
			AUX2=0;
			delay(1);
			cont_Lectura=cont_Lectura-1;
			MatarProcesos();
			pthread_cancel(t1);
			cout<<cont_Lectura<<endl; 
			if(contador==1)
				pthread_create(&t1, NULL, &Deletrear, (void*)1);
			if(contador==2)
				pthread_create(&t1, NULL, &Deletrear_E, (void*)1);
		}
		if(digitalRead(ENCODER_A) && digitalRead(ENCODER_B)){
			AUX1=0;
			AUX2=0;
		}
		delay(1);
		if(cont_Lectura==65535)
				cont_Lectura=42;
		if(cont_Lectura==43)
				cont_Lectura=0;
//*************************************************************************************************
//--------------------------------------------CONDICION APAGAR------------------------------------------------------
		if(apagar>=400){
				MatarProcesos();
				pthread_cancel(t1);
				cout<<"Apagando el dispositivo"<<endl;
				system("echo 'Apagando el dispositivo' | festival --tts");
				sleep(1);
				system("sudo shutdown -h now");
				sleep(2);
			}
//------------------------------------------SELECCION DE MODO (QUITAR O REEMPLAZAR)--------------------------
		if(digitalRead(Boton_Seleccion)==1)
		{
			apagar=0;
			Rebote();
			MatarProcesos();
			system("echo -n ' ' > /home/pi/glove/Palabra_Braile_2.txt");
			cont_Lectura=0;
			Pala_pos_vector=0;
			contador=contador+1;	
//-----------------------------------------------------------ENVIO SERIAL-----------------------------------------------------------
			if(contador==3){
				fd=serialOpen("/dev/ttyAMA0",9600);	
				wiringPiSetup();
				cout<<"Abriste el Puerto serial"<<endl;
				serialPutchar(fd,86);
				cout<<"Escribiste R en el Puerto serial"<<endl;
				delay(3);
				serialClose(fd);	
				cout<<"Cerraste el Puerto serial"<<endl;
			}
//------------------------------------------------------------------------------------------------------------------------------------------
			if(contador==4)
				contador =1;
			cout<<contador<<endl;
			switch(contador)
			{
			case 0://modo de Ayuda
				pthread_cancel(t1);
				pthread_create(&t1, NULL, &modoAyuda, (void*)1);
				break;
			case 1://modo LecturaBraile
				 pthread_cancel(t1);
				 pthread_create(&t1, NULL, &modoLecturaBraile, (void*)1); 	
				break;
			case 2://modo Escritura Braile
				pthread_cancel(t1);				
				pthread_create(&t1, NULL, &modoEscrituraBraile, (void*)1); 
				break;	
			case 3://modo Escribir Palabras
				pthread_cancel(t1);
				pthread_create(&t1, NULL, &modoEscribirPalabras, (void*)1); 
				break;
			default:
				break;
			}
		}
	}	
}
//+++++++++++++++++++++++++++++FUNCION PRINCIPAL+++++++++++++++++++++++++++++
int main(void)
{	
	pthread_t t1,t2;
	pthread_create(&t1, NULL, &leerGPIO, (void*)1); 
	void* result;
	pthread_join(t1,&result);
return 0;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
